;--------------------------------------
; Sets ACE16 clock from IDE64 clock
; Josef Soucek 1999
; E-mail: josef.soucek@spt.cz
;--------------------------------------

              .include "acehead.s"

              *= aceAppAddress

              jmp main
              .byte aceID1,aceID2,aceID3
              .byte 64,0                ;** stack,reserved

main          = *
              lda #<infoMsg
              ldy #>infoMsg
              sta zp+0
              sty zp+1
              lda #<infoMsgEnd-infoMsg
              ldy #>infoMsgEnd-infoMsg
              ldx #stdout
              jsr write

              jsr read_time
              jsr convert_time
              lda #<ace_date_buff
              ldy #>ace_date_buff
              jsr aceTimeSetDate
              rts

;--------------------------------------
clockport  = $de5f
clockreset = $defb 

read_time     = *
              sei
              lda #$02
              sta clockreset  ;enable clock chip

              lda #%10111111  ;clock burst read command
              jsr sendbyte

              ldy #$00
input         jsr readbyte
              sta ide_date_buff,y
              iny
              cpy #$08        ;no. of bytes
              bne input

              lda #$00        ;disable clock chip
              sta clockreset

              cli
              rts
;--------------------------------------

sendbyte      sta clockport ; bit 0
              lsr a
              sta clockport ; bit 1
              lsr a
              sta clockport ; bit 2
              lsr a
              sta clockport ; bit 3
              lsr a
              sta clockport ; bit 4
              lsr a
              sta clockport ; bit 5
              lsr a
              sta clockport ; bit 6
              lsr a
              sta clockport ; bit 7
              rts

readbyte      lda #$00
              sta zp
              lda clockport  ; bit 0
              lsr a
              ror zp
              lda clockport  ; bit 1
              lsr a
              ror zp
              lda clockport  ; bit 2
              lsr a
              ror zp
              lda clockport  ; bit 3
              lsr a
              ror zp
              lda clockport  ; bit 4
              lsr a
              ror zp
              lda clockport  ; bit 5
              lsr a
              ror zp
              lda clockport  ; bit 6
              lsr a
              ror zp
              lda clockport  ; bit 7
              lsr a
              ror zp
              lda zp
              rts    
;-----------------------------------------

convert_time  = *
              lda ide_date_buff    ;ss
              sta ace_date_buff+6
              lda ide_date_buff+1  ;mm
              sta ace_date_buff+5
              lda ide_date_buff+2  ;hh
              sta ace_date_buff+4
              lda ide_date_buff+3  ;DD
              sta ace_date_buff+3
              lda ide_date_buff+4  ;MM
              sta ace_date_buff+2
              lda ide_date_buff+6  ;YY
              sta ace_date_buff+1
              cmp #$80
              bcc c_21
              lda #$19             ;years 1980-$1999
              sta ace_date_buff
              rts
c_21          lda #$20             ;years $2000-$2079
              sta ace_date_buff
              rts

;--------------------------------------
; Date and time in BCD
;--------------------------------------
ace_date_buff = *
;              .byte $19,$99,$06,$20,$17,$10,$00,$00,$07,$99,$99,$99
              *= *+1    ;YY 
              *= *+1    ;YY
              *= *+1    ;MM
              *= *+1    ;DD
              *= *+1    ;hh
              *= *+1    ;mm
              *= *+1    ;ss
               .byte $00,$07,$99,$99,$99
;              *= *+1    ;tt - hunderts of second
;              *= *+1    ;tw - day of the week 0=sunday 7=unknown
;              *= *+1    ;GG - offset from GMT $80-negative 99=unknown
;              *= *+1    ;gg - offset in minutes
;              *= *+1    ;aa - time-zone accurancy 99=unknown
;--------------------------------------
ide_date_buff  = *
               * = *+1   ;ss
               * = *+1   ;mm
               * = *+1   ;hh
               * = *+1   ;DD
               * = *+1   ;MM
               * = *+1   ;
               * = *+1   ;YY ($00-$99)
               * = *+1   ;
;--------------------------------------
infoMsg        = *
               .byte "R"+128
               .text "EADING THE TIME FROM "
               .byte "I"+128,"D"+128,"E"+128
               .text "'S REAL-TIME CLOCK CHIP..."
               .byte chrCR
infoMsgEnd     = *
